#include <avr/io.h>

void uart_init(void) {
    //9600,n,8,1
    UCSRB=0x18;
    UCSRC=0x06;
    UBRRL=79;
    UBRRH=0;
}

//receive a char
char uart_recv(void) {
    while(!(UCSRA&0x80));
    return UDR;
}

//send a char
void uart_send(char c) {
    while(!(UCSRA&0x20));
    UDR=c;
}