#!/usr/bin/php
<?
include("wb_inc.php");
include("hershey_inc.php");

$fnt=load_font("hershey");
$map=get_mapping("romans.hmp");

//min and max pos, in cm, with 0,0 being tol peft of the whiteboard
$minx=1; $miny=14;
$maxx=57; $maxy=63;
$idlex=20; $idley=5;
//scaling factor
$sc=(1.4)/20;

//open comport
$com=wb_open();
moveto($com,$idlex,$idley,0);

//listen at port 6831
//Read a text starting with two coordinates and the text separated by spaces.
//Drawing starts on closing of socket.
$ls=socket_create(AF_INET,SOCK_STREAM,getprotobyname("tcp"));
socket_bind($ls,"0.0.0.0",6831) || die("Error creating socket.");
socket_listen($ls) || die("Error listening");
while ($sck=socket_accept($ls)) {
    $in="";
    do {
	$t=socket_read($sck,1024);
	if ($t) $in.=$t;
	echo "Read $t\n";
    } while (!($t=="" || $t===FALSE));
    $i=explode(" ",$in,3);
    $x=$i[0];
    $y=$i[1];
    $s=$i[2];
    if ($x<$minx) $x=$minx;
    if ($x>$maxx) $x=$maxx;
    if ($y<$miny) $y=$miny;
    if ($y>$maxy) $y=$maxy;
    
    echo "Plotting @ $x,$y: $s\n";

    moveto($com,$x,$y,0);
    //draw chars
    for ($sp=0; $sp<strlen($s); $sp++) {
	$c=substr($s,$sp,1);
	echo $c;
	if ($c=="\n") { //handle enter
	    $y+=30*$sc; $x=$minx;
	    moveto($com,$x,$y,0);
	} else {
	    $hc=get_char($c,$map,$fnt,$sc);
	    if (($hc["w"]+$x)>$maxx) { //handle x overflow
		$x=$minx; $y+=30*$sc;
	    }
	    if ($y>$maxy) $y=$miny; //handle y overflow
	    foreach($hc["coord"] as $p) { //plot coordinates from hershey char
		move_precise($com,$p["x"]+$x,$p["y"]+$y,$p["d"]);
	    }
	    $x+=$hc["w"];
	}
    }
    moveto($com,$idlex,$idley,0);
}

?>